<?php
namespace Indeterminado\Repositories;

class Objetpropfas extends \Doctrine\ORM\EntityRepository
{
    public static function getTxObjetProposta($nrProposta, $nrVersao, $nrOrg)
    {
        $sql = "SELECT TXOBJETPROPFAS
                  FROM OBJETPROPFAS
                 WHERE NRPROPOSFAS  = :P_PROPOSTA
                   AND NRVERPROPFAS = :P_VERSAO
                   AND NRORG        = :P_ORG";

        $params = array("P_PROPOSTA" => $nrProposta,
                        "P_VERSAO"   => $nrVersao,
                        "P_ORG"      => $nrOrg);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function insertObjetivoPropostaComercial($campos){
        $sql = "INSERT INTO OBJETPROPFAS
                      (NRPROPOSFAS, NRVERPROPFAS, TXOBJETPROPFAS, DTINCLUSAO, NRORG)
                   VALUES
                      (:NRPROPOSFAS, :NRVERPROPFAS, rawtohex(:TXOBJETPROPFAS), SYSDATE, :NRORG)";

        $params = array(
            "NRPROPOSFAS"    => $campos['NRPROPOSFAS'],
            "NRVERPROPFAS"   => $campos['NRVERPROPFAS'],
            "TXOBJETPROPFAS" => $campos['TXOBJETPROPFAS'],
            "NRORG"          => $campos['NRORG'],
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function atualizaObjetivoPropostaComercial($campos){
        $sql = "UPDATE OBJETPROPFAS
                   SET TXOBJETPROPFAS = RAWTOHEX(:TXOBJETPROPFAS)
                 WHERE NRPROPOSFAS    = :NRPROPOSFAS
                   AND NRVERPROPFAS   = :NRVERPROPFAS
                   AND NRORG          = :NRORG";

        $params = array(
            "NRPROPOSFAS"    => $campos['NRPROPOSFAS'],
            "NRVERPROPFAS"   => $campos['NRVERPROPFAS'],
            "TXOBJETPROPFAS" => $campos['TXOBJETPROPFAS'],
            "NRORG"          => $campos['NRORG'],
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function deleteObjetivoPropostaComercial($nrProposta, $nrVersao){
        $sql = "DELETE FROM OBJETPROPFAS
                 WHERE NRPROPOSFAS   = :NRPROPOSFAS
                   AND NRVERPROPFAS  = :NRVERPROPFAS";
        
        $params = array(
            "NRPROPOSFAS"  => $nrProposta,
            "NRVERPROPFAS" => $nrVersao
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }
}