/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FASECONT                                                 */
/* Tabela : FASECONT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 17/08/2004 - Welbert G. Moitinha                                           */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FASECONT
BEFORE INSERT OR UPDATE OR DELETE
ON FASECONT FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFACO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDFASECONT <> :NEW.CDFASECONT) OR
         (:OLD.NMFASECONT <> :NEW.NMFASECONT) THEN
         :NEW.DTULTATUFACO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FASECONT', '', 'CDFASECONT='||:OLD.CDFASECONT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FASECONT MODIFY DTULTATUFACO DEFAULT SYSDATE
/
