/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CNUN                                                     */
/* Tabela : CONVUNID                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CNUN'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CNUN
GO

CREATE TRIGGER DTULTATU_CNUN
ON CONVUNID
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONVUNID', null, 'SGUNIDDE=' + SGUNIDDE + ';'+
                                       'SGUNIDPARA='+ SGUNIDPARA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONVUNID
      SET DTULTATUCNUN = GETDATE()
      FROM INSERTED;
   END;
END;
GO

