package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.interactions.Actions;

public class PrevisaoDeConsumoPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaConsumo = By.xpath("//span[text() = 'Consumo']");
    By acessaPrevisaoDeConsumo = By.xpath("//span[text() = 'Cálculo da Previsão de Consumo']");
    By limpaFiltroRelatorio = By.xpath("//div[@id = 'REPORT_NAME']//span[@zh-icon= 'no-border close-x']");
    By abreFiltroRelatorio = By.xpath("//div[@id = 'REPORT_NAME']//span[@zh-icon= 'no-border search']");
    By relPrevisaoConsumoTotalPeriodo = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Total do Período)']");
    By relPrevisaoConsumoTotalPeriodoCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Total do Período com Custo)']");
    By relPrevisaoConsumoDataProduto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Data por Produto)']");
    By relPrevisaoConsumoDataPorProdutoComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Data por Produto com Custo)']");
    By relPrevisaoConsumoProdutoPorData = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Produto por Data)']");
    By relPrevisaoConsumoProdutoPorDataComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Produto por Data com Custo)']");
    By relPrevisaoConsumoConsolidado = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo - Consolidado']");
    By relPrevisaoConsumoConsolidadoParticularidade = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo - Consolidado - Particularidades']");
    By relPrevisaoConsumoPorPratoComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (por Prato / com Custo)']");
    By relPrevisaoConsumoUnidadePorProduto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Unidade por Produto)']");
    By limpaDataPrevisao = By.xpath("//div[@id = 'INTERVAL']//span[@zh-icon= 'no-border close-x']");
    By campoDataPrevisao = By.xpath("//div[@id = 'INTERVAL']");
    By btnAlteraPeriodo = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By dtInicial = By.xpath("//div[@data-date='01/01/2023']");
    By dtFinal = By.xpath("//div[@data-date='30/01/2023']");
    By btnOkDataPrevisao = By.xpath("//*[@class= 'zh-footer-right']//span[text() = 'OK']");
    By lupaAgrupamentoUnidade = By.xpath("//div[@data-zh-id='2730316301672544541659']//span[@zh-icon='no-border search']");
    By campoFilial = By.xpath("//div[@id = 'NMFILIAL']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By insereInformacaoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By btnOk = By.xpath("//span[text()= 'Ok']");
    By selecionaInformacaoBusca = By.xpath("//div[@class= 'tr cell1']");
    By checkBoxTodasUnidades = By.xpath("//label[@for= 'zh-checkbox-Todos_Unidade']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxTodosServicos = By.xpath("//label[@for= 'zh-checkbox-Todos_Servico']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By checkBoxDesconsideraSubGrupoProduto = By.xpath("//label[@for= 'zh-checkbox-Desconsiderar_SubProd']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoSubGrupoProduto = By.xpath("//div[@id = 'NMSUBGRPROD']");
    By campoProdInicial = By.xpath("//div[@id= 'NMPRODUTOINI']//span[@zh-icon='no-border search']");
    By produtoInicial = By.xpath("//div[@class = 'tr cell1']//span[text() = 'MATERIA PRIMA']");
    By campoProdFinal = By.xpath("//div[@id= 'NMPRODUTOFIN']//span[@zh-icon='no-border search']");
    By produtoFinal = By.xpath("//div[@class = 'tr cell2']//span[text() = 'MATERIA PRIMA']");
    By limpaInformacaoNivel = By.xpath("//div[@id = 'TIPONIVEL']//span[@zh-icon='no-border close-x']");
    By lupaInformacaoNivel = By.xpath("//div[@id = 'TIPONIVEL']//span[@zh-icon='no-border search']");
    By defineNivel = By.xpath("//ul[@class = 'zh-template-list']//span[text() = '1']");
    By campoAcrescimo = By.xpath("//input[@id = 'ACRESCIMO']");
    By limpaFiltroTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon=no-border close-x']");
    By lupaFiltrTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon= 'no-border search']");
    By campoArredondamento = By.xpath("//div[@data-zh-id='2730316301386053601481']//span[@class = 'current']");
    By opcaoCompras = By.xpath("//li[text() = 'Compras']");
    By opcaoRequisicao = By.xpath("//li[text() = 'Requisição']");
    By campoOrdenacao = By.xpath("//div[@data-zh-id='273031630574623884482']//span[@class = 'current']");
    By opcaoAlfabetica = By.xpath("//li[text() = 'Alfabética']");
    By checkBoxCalcularAntesDeImprimir = By.xpath("//label[@for = 'zh-checkbox-CALCPREVCONS']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxImprimirPaginaFiltro = By.xpath("//label[@for = 'zh-checkbox-IMPRIME_F']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxImprimirServico = By.xpath("//label[@for = 'zh-checkbox-IMPRIME_S']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnCalcular = By.xpath("//li[@data-zh-id='2730316307724902951725']");
    By confirmaMensagem = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");
    By btnRelatorio = By.xpath("//li[@data-zh-id='27303163034557916471723']//span[text() = 'Relatório']");
    By opcaoPDF = By.xpath("//label[@for = 'radio-QR2TYPE-PDF']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By opcaoExcel = By.xpath("//label[@for = 'radio-QR2TYPE-XLSX']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");



    public void navegarPrevisaoDeConsumo(){
        waitForElement(clicaMenu);
        waitForElement(usernameLoginInfoTextArea);
        tempo();
        click(clicaMenu);
        click(clicaPlanejamento);
        click(clicaConsumo);
        click(acessaPrevisaoDeConsumo);
        tempo();
    }

    public void emiteRelaorio(String DTINI, String DTFIM){
        Actions actions = new Actions(driver);
        click(limpaDataPrevisao);
        actions.moveToElement(driver.findElement(campoDataPrevisao), -150, 0).click().build().perform();
        tempo();
       /* click(btnAlteraPeriodo);
        tempo();*/
        click(dtInicial);
        click(dtFinal);
        click(btnOkDataPrevisao);
        click(campoFilial);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(lupaFiltro);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"0002");
        tempo();
        click(selecionaInformacaoBusca);
        click(btnOk);
        tempo();
        click(checkBoxTodosServicos);
        click(campoServico);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,"00002");
        tempo();
        click(selecionaInformacaoBusca);
        click(btnOk);
        tempo();
        click(campoProdInicial);
        tempo();
        click(lupaFiltro);
        click(produtoInicial);
        click(campoProdFinal);
        tempo();
        click(lupaFiltro);
        click(produtoFinal);
        click(limpaInformacaoNivel);
        click(lupaInformacaoNivel);
        tempo();
        click(defineNivel);
        click(campoAcrescimo);
        clearAndSendKeys(campoAcrescimo,"2");
        click(checkBoxCalcularAntesDeImprimir);
        click(checkBoxImprimirPaginaFiltro);
        click(checkBoxImprimirServico);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        scrollPrevisao();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoTotalPeriodoCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoDataProduto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoDataPorProdutoComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoProdutoPorData);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoProdutoPorDataComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoConsolidado);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoConsolidadoParticularidade);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoPorPratoComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoUnidadePorProduto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
    }

    public void emiteRelaoriosFiltros(){
        click(checkBoxTodasUnidades);
        click(checkBoxTodosServicos);
        tempo();
        click(campoAcrescimo);
        clearAndSendKeys(campoAcrescimo,"4");
        click(checkBoxImprimirPaginaFiltro);
        click(checkBoxImprimirServico);
        click(btnCalcular);
        tempo();
        click(confirmaMensagem);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        scrollPrevisao();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoTotalPeriodoCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoDataProduto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoDataPorProdutoComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoProdutoPorData);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoProdutoPorDataComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoConsolidado);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoConsolidadoParticularidade);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoPorPratoComCusto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(limpaFiltroRelatorio);
        click(abreFiltroRelatorio);
        click(lupaFiltro);
        tempo();
        click(relPrevisaoConsumoUnidadePorProduto);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
    }









}
