package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.AlergenicoProdutoFlows;
import com.javaseleniumtemplate.pages.AlergenicoProdutoPage;
import org.testng.annotations.Test;

public class AlergenicoProdutoTests extends TestBase {

    AlergenicoProdutoPage alergenicoProdutoPage;
    AlergenicoProdutoFlows alergenicoProdutoFlows;
    LoginFlows loginFlows;


    //adicionar alergênicos ao produto 'CINERARIA MARITIMA  PLANTA INTEIRA'
    //adicionar mais um alergênico ao produto
    //realizar a verificação dos alergênicos adicionados
    //excluir apenas um alergênico
    //excluir todos os alergênicos
    @Test
    public void alergenicoProd() {
        alergenicoProdutoPage = new AlergenicoProdutoPage();
        alergenicoProdutoFlows = new AlergenicoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoProdutoFlows.navegateTelaAlergenicosProduto();
        alergenicoProdutoPage.selecionarProduto();
        alergenicoProdutoPage.addAlergenicos();
        alergenicoProdutoPage.verificarAlergenicosAdd();
        alergenicoProdutoPage.adicionarCrustaceo();
        alergenicoProdutoPage.excluirAlergenico();
        alergenicoProdutoPage.excluirTodosAlergenicos();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


    //cadastro automático dos alregênicos amendoim e moluscos, nos produtos CARBONATO DE MAGNESIO e CARBONATO DE MAGNESIO 500G
    //verificação dos alergênicos adicionados nos produtos
    //exclusão dos alergênicos por por do cadastro automático
    //verificação dos campos obrigatórios do formulário de cadastro automáticos
    @Test
    public void cadastroAutomatico() {
        alergenicoProdutoPage = new AlergenicoProdutoPage();
        alergenicoProdutoFlows = new AlergenicoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoProdutoFlows.navegateTelaAlergenicosProduto();
        alergenicoProdutoPage.preencherFormCadAutomaticoInclusao();
        alergenicoProdutoPage.verificarCadAutomatico();
        alergenicoProdutoPage.preencherFormCadAutomatidoExcluir();
        alergenicoProdutoPage.verificarExclusaoAutomatica();
        alergenicoProdutoPage.camposObrigatorioCadAuto();


        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
